; Forecast v3.00
; (C) 2003 Michael Peterson.
;
;This library is free software; you can redistribute it and/or
;modify it under the terms of the GNU Lesser General Public
;License as published by the Free Software Foundation; either
;version 2.1 of the License, or (at your option) any later version.
;
;This library is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
;Lesser General Public License for more details.
;
;You should have received a copy of the GNU Lesser General Public
;License along with this library; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
;
Hook_Token:
	add a,e
	push hl
	push de
	ld hl,3F6h
	or a
	sbc hl,de
	jr z,Hook_Token_Real
	pop hl
	ld	de,0548h
	or	a
	sbc hl,de
	ex	de,hl
	pop hl
	ret c
	rr	e
	ld	a,e
	jr	Hook_Token_Get
Hook_Token_Real:
	pop de
	pop hl
	ld a,(tokenHookPtr+3)
	cp 2
	jr z,Hook_Token_RealGO
	scf
	ret
Hook_Token_RealGO:
	ld a,(rawkeyhookptr+3)
	ld b,a
	sub 0CFh
	ret c
	ld hl,(editCursor)
	dec hl
	ld (hl),b
Hook_Token_Get:
	sla a
	ld	e,a
	ld	d,0
	ld	hl,Hook_Token_Table
	add hl,de
	ld	e,(hl)
	inc hl
	ld	d,(hl)
	ex	de,hl
	inc hl
	ld	b,0
	ld	c,(hl)
	dec hl
	inc bc
	inc bc
	inc bc
	ld	de,localtokstr
	ldir
	xor a
	ld	(rawkeyhookptr+3),a
	ld	hl,localtokstr
	ret
Hook_Token_Table:
	DW Hook_Token_Symbolic_csc
	DW Hook_Token_Symbolic_csc1
	DW Hook_Token_Symbolic_sec
	DW Hook_Token_Symbolic_sec1
	DW Hook_Token_Symbolic_cot
	DW Hook_Token_Symbolic_cot1
	DW Hook_Token_Symbolic_csch
	DW Hook_Token_Symbolic_csch1
	DW Hook_Token_Symbolic_sech
	DW Hook_Token_Symbolic_sech1
	DW Hook_Token_Symbolic_coth
	DW Hook_Token_Symbolic_coth1
	DW Hook_Token_Symbolic_d
	DW Hook_Token_Symbolic_simp
	DW Hook_Token_Symbolic_sign
	DW Hook_Token_Symbolic_version
	DW Hook_Token_Symbolic_arclength
	DW Hook_Token_Symbolic_let
	DW Hook_Token_Symbolic_numstr
	DW Hook_Token_Symbolic_pretty
	;DW Hook_Token_SpriteToken
	;DW Hook_Token_RomanToken
	;DW Hook_Token_RootToken
	;DW Hook_Token_FactorToken
	;DW Hook_Token_GammaToken
	;DW Hook_Token_BaseToken
	;DW Hook_Token_LinkGetToken
	;DW Hook_Token_LinkSendToken
	;DW Hook_Token_ModuloToken
	;DW Hook_Token_ConstantToken
	;DW Hook_Token_SubfactorialToken
	;DW Hook_Token_ProgramToken
	;DW Hook_Token_RestoreMemoryToken
;Length
	DW Hook_Token_KmMi
	DW Hook_Token_MiKm

	DW Hook_Token_MiFt
	DW Hook_Token_FtMi

	DW Hook_Token_MFt
	DW Hook_Token_FtM

	DW Hook_Token_CmIn
	DW Hook_Token_InCm

	DW Hook_Token_LatKm
;Area
	DW Hook_Token_cmin2
	DW Hook_Token_incm2

	DW Hook_Token_mft2
	DW Hook_Token_ftm2
;Volume
	DW Hook_Token_cmin3
	DW Hook_Token_incm3

	DW Hook_Token_lcm3
	DW Hook_Token_cml3

	DW Hook_Token_lgal
	DW Hook_Token_gall
;Mass
	DW Hook_Token_glb
	DW Hook_Token_lbg
	DW Hook_Token_goz
	DW Hook_Token_ozg
;Temp
	DW Hook_Token_cf
	DW Hook_Token_fc
	DW Hook_Token_fk
	DW Hook_Token_kf

Hook_Token_Symbolic_csc:
	DB 0,4,"csc(",0
Hook_Token_Symbolic_csc1:
	DB 0,5,"csc",linverse,"(",0
Hook_Token_Symbolic_sec:
	DB 0,4,"sec(",0
Hook_Token_Symbolic_sec1:
	DB 0,5,"sec",linverse,"(",0
Hook_Token_Symbolic_cot:
	DB 0,4,"cot(",0
Hook_Token_Symbolic_cot1:
	DB 0,5,"cot",linverse,"(",0
Hook_Token_Symbolic_csch:
	DB 0,5,"csch(",0
Hook_Token_Symbolic_csch1:
	DB 0,6,"csch",linverse,"(",0
Hook_Token_Symbolic_sech:
	DB 0,5,"sech(",0
Hook_Token_Symbolic_sech1:
	DB 0,6,"sech",linverse,"(",0
Hook_Token_Symbolic_coth:
	DB 0,5,"coth(",0
Hook_Token_Symbolic_coth1:
	DB 0,6,"coth",linverse,"(",0
Hook_Token_Symbolic_d:
	DB 0,2,"d(",0
Hook_Token_Symbolic_simp:
	DB 0,5,"simp(",0
Hook_Token_Symbolic_sign:
	DB 0,5,"sign(",0
Hook_Token_Symbolic_version:
	DB 0,8,"version(",0
Hook_Token_Symbolic_arclength:
	DB 0,10,"arclength(",0
Hook_Token_Symbolic_let:
	DB 0,4,"let(",0
Hook_Token_Symbolic_numstr:
	DB 0,7,"numStr(",0
Hook_Token_Symbolic_pretty:
	DB 0,7,"pretty(",0
Hook_Token_SpriteToken:
	DB 0,7,"sprite(",0
Hook_Token_RomanToken:
	DB 0,8,"Rom",5,"Dec(",0
Hook_Token_RootToken:
	DB 0,6,"simp",10h,"(",0
Hook_Token_FactorToken:
	DB 0,7,"factor(",0
Hook_Token_GammaToken:
	DB 0,6,"gamma(",0
Hook_Token_BaseToken:
	DB 0,10,"baseInput(",0
Hook_Token_LinkGetToken:
	DB 0,8,"linkGet(",0
Hook_Token_LinkSendToken:
	DB 0,9,"linkSend(",0
Hook_Token_ModuloToken:
	DB 0,4,"mod(",0
Hook_Token_ConstantToken:
	DB 0,6,"const(",0
Hook_Token_SubfactorialToken:
	DB 0,3,"!n(",0
Hook_Token_ProgramToken:
	DB 0,8,"program(",0
Hook_Token_RestoreMemoryToken:
	DB 0,11,"RestoreMem(",0

;Length
Hook_Token_KmMi:
	DB 0,6,"km",5,"mi(",0
Hook_Token_MiKm:
	DB 0,6,"mi",5,"km(",0

Hook_Token_MiFt:
	DB 0,6,"mi",5,"ft(",0
Hook_Token_FtMi:
	DB 0,6,"ft",5,"mi(",0

Hook_Token_MFt:
	DB 0,5,"m",5,"ft(",0
Hook_Token_FtM:
	DB 0,5,"ft",5,"m(",0

Hook_Token_CmIn:
	DB 0,6,"cm",5,"in(",0
Hook_Token_InCm:
	DB 0,6,"in",5,"cm(",0

Hook_Token_LatKm:
	DB 0,9,"1",0D4h,"Lat",5,"km(",0
;Area
Hook_Token_cmin2:
	DB 0,8,"cm",lsquare,5,"mi",lsquare,"(",0
Hook_Token_incm2:
	DB 0,8,"in",lsquare,5,"cm",lsquare,"(",0

Hook_Token_mft2:
	DB 0,7,"m",lsquare,5,"ft",lsquare,"(",0
Hook_Token_ftm2:
	DB 0,7,"ft",lsquare,5,"m",lsquare,"(",0
;Volume
Hook_Token_cmin3:
	DB 0,8,"cm",lcube,5,"in",lcube,"(",0
Hook_Token_incm3:
	DB 0,8,"in",lcube,5,"cm",lcube,"(",0

Hook_Token_lcm3:
	DB 0,10,"liter",5,"cm",lcube,"(",0
Hook_Token_cml3:
	DB 0,10,"cm",lcube,5,"liter(",0

Hook_Token_lgal:
	DB 0,10,"liter",5,"gal(",0
Hook_Token_gall:
	DB 0,10,"gal",5,"liter(",0
;Mass
Hook_Token_glb:
	DB 0,5,"g",5,"lb(",0
Hook_Token_lbg:
	DB 0,5,"lb",5,"g(",0
Hook_Token_goz:
	DB 0,5,"g",5,"oz(",0
Hook_Token_ozg:
	DB 0,5,"oz",5,"g(",0
;Temp
Hook_Token_cf:
	DB 0,6,0D4h,"C",5,0D4h,"F(",0
Hook_Token_fc:
	DB 0,6,0D4h,"F",5,0D4h,"C(",0
Hook_Token_fk:
	DB 0,5,0D4h,"F",5,"K(",0
Hook_Token_kf:
	DB 0,5,"K",5,0D4h,"F(",0

num32: 		db 00h,81h,32h,00h,00h,00h,00h,00h
num273: 	db 00h,82h,27h,30h,00h,00h,00h,00h
;
kmmi:		db	00h,7Fh,62h,00h,00h,00h,00h,00h
mikm:		db	00h,80h,16h,10h,00h,00h,00h,00h
;
mift:		db	00h,83h,52h,80h,00h,00h,00h,00h
ftmi:		db	00h,7Ch,38h,70h,00h,00h,00h,00h
;
mft:		db	00h,80h,32h,80h,00h,00h,00h,00h
ftm:		db	00h,7Fh,30h,50h,00h,00h,00h,00h
;
cmin:		db	00h,7Fh,39h,37h,00h,78h,74h,00h
incm:		db	00h,7Fh,39h,37h,00h,78h,74h,00h

latkm:		db	00h,82h,11h,10h,00h,00h,00h,00h
kmlat:		db	00h,7Fh,39h,37h,00h,78h,74h,00h

cmin2:		db	00h,7Fh,15h,00h,00h,00h,00h,00h
incm2:		db	00h,80h,66h,70h,00h,00h,00h,00h
;
mft2:		db	00h,81h,10h,76h,00h,00h,00h,00h
ftm2:		db	00h,7Fh,92h,94h,00h,00h,00h,00h
;
cmin3:		db	00h,7Eh,60h,00h,00h,00h,00h,00h
incm3:		db	00h,81h,16h,39h,00h,00h,00h,00h
;
lcm3:		db	00h,83h,10h,00h,00h,00h,00h,00h
cm3l:		db	00h,7Dh,10h,00h,00h,00h,00h,00h
;
lgal:		db	00h,7Fh,26h,40h,00h,00h,00h,00h
gall:		db	00h,80h,37h,88h,00h,00h,00h,00h
;
glb:		db	00h,7Dh,20h,00h,00h,00h,00h,00h
lbg:		db	00h,82h,50h,00h,00h,00h,00h,00h
;
goz:		db	00h,7Eh,35h,00h,00h,00h,00h,00h
ozg:		db	00h,81h,28h,57h,00h,00h,00h,00h
;
cf: 		db	00h,80h,18h,00h,00h,00h,00h,00h
fc:			db	00h,7Fh,55h,55h,55h,55h,55h,56h
;
